package com.myoa.engineering.crawl.shopping.dto.slack;

import com.fasterxml.jackson.annotation.JsonProperty;

import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;

/**
 * SlackMessageDTO
 * @author Shin Woo-jin (woo-jin.shin@linecorp.com)
 * @since 2021-11-14
 *
 */
@Getter
@NoArgsConstructor
public class SlackMessageDTO implements MessageDTO {

    private final static long serialVersionUID = 4737608709660494713L;

    private String text;
    private String channel;
    private String username;

    @JsonProperty("icon_emoji")
    private String iconEmoji;

    @Builder
    public SlackMessageDTO(String text, String channel, String username, String iconEmoji) {
        this.text = text;
        this.channel = channel;
        this.username = username;
        this.iconEmoji = iconEmoji;
    }

    public void applyText(String text) {
        this.text = text;
    }
}
