package com.myoa.engineering.crawl.shopping.infra.client.slack;

import com.myoa.engineering.crawl.shopping.configuration.slack.properties.SlackSecretProperties;
import com.myoa.engineering.crawl.shopping.dto.slack.SlackMessageDTO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class MongeShoppingBotSlackMessageSender {

    private static final String SLACK_SECRET_UNIT_NAME = "shopping-crawler";

    private final SlackSecretProperties.SlackSecretPropertiesUnit slackProperties;
    private final SlackAPIClient slackAPIClient;
    private final String token;

    public MongeShoppingBotSlackMessageSender(SlackAPIClient slackAPIClient,
                                              SlackSecretProperties slackSecretProperties) {
        this.slackAPIClient = slackAPIClient;
        this.slackProperties = slackSecretProperties.find(SLACK_SECRET_UNIT_NAME);
        this.token = slackProperties.getToken();
    }

    public SlackMessageDTO ofMessageTemplate() {
        return SlackMessageDTO.builder()
                              .channel(slackProperties.getChannel())
                              .iconEmoji(slackProperties.getIconEmoji())
                              .username(slackProperties.getUsername())
                              .build();
    }

    public SlackMessageDTO ofMessage(String text) {
        return SlackMessageDTO.builder()
                              .channel(slackProperties.getChannel())
                              .iconEmoji(slackProperties.getIconEmoji())
                              .username(slackProperties.getUsername())
                              .text(text)
                              .build();
    }
}
